Building Angular Apps with the Nx Standalone Projects Setup

In this tutorial you'll learn how to use Angular with Nx in a "standalone" (non-monorepo) setup. Not to be confused with the "Angular Standalone API", a standalone project in Nx is a non-monorepo setup where you have a single application at the root level. This setup is very similar to what the Angular CLI gives you.

What will you learn?

  • how to create a new standalone (single-project) Nx workspace setup for Angular
  • how to run a single task (i.e. serve your app) or run multiple tasks in parallel
  • how to leverage code generators to scaffold components
  • how to modularize your codebase and impose architectural constraints for better maintainability
  • how to speed up CI with Nx Cloud ⚡
Looking for Angular monorepos?

Note, this tutorial sets up a repo with a single application at the root level that breaks out its code into libraries to add structure. If you are looking for an Angular monorepo setup then check out our Angular monorepo tutorial.

Final Code

Here's the source code of the final result for this tutorial.

Also, if you prefer learning with a video, join Juri and walk through the tutorial, step by step together.

Creating a new Angular App

Create a new Angular application with the following command:

~

npx create-nx-workspace@latest myngapp --preset=angular-standalone

1 2NX Let's create a new workspace [https://nx.dev/getting-started/intro] 3 4✔ Which bundler would you like to use? · esbuild 5Default stylesheet format · css 6Do you want to enable Server-Side Rendering (SSR) and Static Site Generation (SSG/Prerendering)? · No 7Test runner to use for end to end (E2E) tests · cypress 8✔ Which CI provider would you like to use? · github 9

You get asked a few questions that help Nx preconfigure your new Angular application. These include:

  • Angular specific questions, such as which bundler to use, whether to enable server-side rendering and which stylesheet format to use
  • General Nx questions, such as whether to enable remote caching with Nx Cloud. Nx comes with built-in local caching. If you want to benefit from this cache in CI, you can enable remote caching which will set up Nx Cloud. This is also a prerequisite for enabling distributed task execution. We'll explore this later in the tutorial.

For the sake of this tutorial, let's respond to all the questions with the default response.

The create-nx-workspace command generates the following structure:

1└─ myngapp 2 ├─ .vscode 3 │ └─ extensions.json 4 ├─ e2e 5 │ ├─ ... 6 │ ├─ project.json 7 │ ├─ src 8 │ │ ├─ e2e 9 │ │ │ └─ app.cy.ts 10 │ │ ├─ ... 11 │ └─ tsconfig.json 12 ├─ src 13 │ ├─ app 14 │ │ ├─ app.component.css 15 │ │ ├─ app.component.html 16 │ │ ├─ app.component.spec.ts 17 │ │ ├─ app.component.ts 18 │ │ ├─ app.config.ts 19 │ │ ├─ app.routes.ts 20 │ │ └─ nx-welcome.component.ts 21 │ ├─ assets 22 │ ├─ favicon.ico 23 │ ├─ index.html 24 │ ├─ main.ts 25 │ ├─ styles.css 26 │ └─ test-setup.ts 27 ├─ jest.config.ts 28 ├─ jest.preset.js 29 ├─ nx.json 30 ├─ package-lock.json 31 ├─ package.json 32 ├─ project.json 33 ├─ README.md 34 ├─ tsconfig.app.json 35 ├─ tsconfig.editor.json 36 ├─ tsconfig.json 37 └─ tsconfig.spec.json 38

The setup includes:

  • a new Angular application at the root of the Nx workspace (src/app)
  • a Cypress based set of e2e tests (e2e/)
  • Prettier preconfigured
  • ESLint & Angular ESLint preconfigured
  • Jest preconfigured

Compared to the Angular CLI, you might notice the addition of an nx.json file and the absence of an angular.json file. Instead of the angular.json file there is a project.json file. Each file is described below:

FileDescription
nx.jsonThis is where we can fine-tune how Nx works, define the cacheable operations, our task pipelines as well as defaults for the Nx generators. Find more details in the reference docs.
project.jsonNx uses this file to define targets that can be run, similar to how the Angular CLI uses the angular.json file. If you're familiar with the Angular CLI you should have no difficulty navigating the project.json file. If you're curious how the two compare, you can learn more in the Nx and Angular CLI comparision article. The project-configuration documentation page has more details on how to use the project.json file.

Serving the App

The most common tasks are already defined in the package.json file:

package.json
1{ 2 "name": "myngapp", 3 "scripts": { 4 "start": "nx serve", 5 "build": "nx build", 6 "test": "nx test" 7 } 8 ... 9} 10

To serve your new Angular application, just run: npm start. Alternatively you can directly use Nx by running:

nx serve

Your application should be served at http://localhost:4200.

Nx uses the following syntax to run tasks:

Syntax for Running Tasks in Nx

Manually Defined Tasks

The project tasks are defined in the project.json file:

1{ 2 "name": "myngapp", 3 ... 4 "targets": { 5 "build": { ... }, 6 "serve": { ... }, 7 "extract-i18n": { ... }, 8 "lint": { ... }, 9 "test": { ... }, 10 "serve-static": { ... }, 11 }, 12} 13

Each target contains a configuration object that tells Nx how to run that target.

1{ 2 "name": "myngapp", 3 ... 4 "targets": { 5 "serve": { 6 "executor": "@angular-devkit/build-angular:dev-server", 7 "configurations": { 8 "production": { 9 "browserTarget": "myngapp:build:production" 10 }, 11 "development": { 12 "browserTarget": "myngapp:build:development" 13 } 14 }, 15 "defaultConfiguration": "development" 16 }, 17 ... 18 }, 19} 20

The most critical parts are:

  • executor - This corresponds to the builder property in an Angular CLI workspace. You can use Angular builders or executors from Nx plugins.
  • options - these are additional properties and flags passed to the executor function to customize it

Learn more about how to run tasks with Nx.

Testing and Linting

Our current setup not only has targets for serving and building the Angular application, but also has targets for unit testing, e2e testing and linting. The test and lint targets are defined in the application project.json file, while the e2e target is inferred from the e2e/cypress.config.ts file. We can use the same syntax as before to run these tasks:

1nx test # runs unit tests using Jest 2nx lint # runs linting with ESLint 3nx e2e e2e # runs e2e tests from the e2e project with Cypress 4

Inferred Tasks

Nx identifies available tasks for your project from tooling configuration files, package.json scripts and the targets defined in project.json. All tasks from the myngapp project are defined in its project.json file, but the companion e2e project has its tasks inferred from configuration files. To view the tasks that Nx has detected, look in the Nx Console, Project Details View or run:

nx show project e2e --web

Project Details View

e2e

Cypress
ESLint

Root: e2e

Type:application

Targets

E2E (CI) 2 targets
  • e2e-ci

    Cypress

    nx:noop

    Cacheable
  • e2e-ci--src/e2e/app.cy.ts

    Cypress

    cypress run --env webServerCommand="nx run myngapp:serve-static" --spec src/e2e/app.cy.ts

    Cacheable
Others 2 targets
  • e2e

    Cypress

    cypress run

    Cacheable
  • lint

    ESLint

    eslint .

    Cacheable

If you expand the e2e task, you can see that it was created by the @nx/cypress plugin by analyzing the e2e/cypress.config.ts file. Notice the outputs are defined as:

1[ 2 "{workspaceRoot}/dist/cypress/e2e/videos", 3 "{workspaceRoot}/dist/cypress/e2e/screenshots" 4] 5

This value is being read from the videosFolder and screenshotsFolder defined by the nxE2EPreset in your e2e/cypress.config.ts file. Let's change their value in your e2e/cypress.config.ts file:

e2e/cypress.config.ts
1// ... 2export default defineConfig({ 3 e2e: { 4 ...nxE2EPreset(__filename, { 5 // ... 6 }), 7 baseUrl: 'http://localhost:4200', 8 videosFolder: '../dist/cypress/e2e/videos-changed', 9 screenshotsFolder: '../dist/cypress/e2e/screenshots-changed', 10 }, 11}); 12

Now if you look at the project details view again, the outputs for the e2e target will be:

1[ 2 "{workspaceRoot}/dist/cypress/e2e/videos-changed", 3 "{workspaceRoot}/dist/cypress/e2e/screenshots-changed" 4] 5

This feature ensures that Nx will always cache the correct files.

You can also override the settings for inferred tasks by modifying the targetDefaults in nx.json or setting a value in your project.json file. Nx will merge the values from the inferred tasks with the values you define in targetDefaults and in your specific project's configuration.

Running Multiple Tasks

In addition to running individual tasks, you can also run multiple tasks in parallel using the following syntax:

myngapp

nx run-many -t test lint e2e

1 2nx run e2e:lint (1s) 3nx run myngapp:lint (1s) 4nx run myngapp:test (2s) 5nx run e2e:e2e (6s) 6 7—————————————————————————————————————————————————————— 8 9NX Successfully ran targets test, lint, e2e for 2 projects (8s) 10

Caching

One thing to highlight is that Nx is able to cache the tasks you run.

Note that all of these targets are automatically cached by Nx. If you re-run a single one or all of them again, you'll see that the task completes immediately. In addition, (as can be seen in the output example below) there will be a note that a matching cache result was found and therefore the task was not run again.

myngapp

nx run-many -t test lint e2e

1 2✔ nx run myngapp:lint [existing outputs match the cache, left as is] 3✔ nx run e2e:lint [existing outputs match the cache, left as is] 4✔ nx run myngapp:test [existing outputs match the cache, left as is] 5✔ nx run e2e:e2e [existing outputs match the cache, left as is] 6 7——————————————————————————————————————————————————————— 8 9 Successfully ran targets test, lint, e2e for 2 projects (143ms) 10 11Nx read the output from the cache instead of running the command for 4 out of 4 tasks. 12

Not all tasks might be cacheable though. You can configure the cache properties in the targets under targetDefaults in the nx.json file. You can also learn more about how caching works.

Creating New Components

Similar to the Angular CLI, Nx comes with code generation abilities. What the Angular CLI calls "Schematics", Nx calls "Generators".

Generators allow you to easily scaffold code, configuration or entire projects. To see what capabilities the @nx/angular plugin ships with, run the following command and inspect the output:

myngapp

npx nx list @nx/angular

1 2NX Capabilities in @nx/angular: 3 4NX Capabilities in @nx/angular: 5 6 GENERATORS 7 8 add-linting : Adds linting configuration to an Angular project. 9 application : Creates an Angular application. 10 component : Generate an Angular Component. 11 ... 12 library : Creates an Angular library. 13 library-secondary-entry-point : Creates a secondary entry point for an Angular publishable library. 14 remote : Generate a Remote Angular Module Federation Application. 15 move : Moves an Angular application or library to another folder within the workspace and updates the project configuration. 16 convert-to-with-mf : Converts an old micro frontend configuration... 17 host : Generate a Host Angular Module Federation Application. 18 ng-add : Migrates an Angular CLI workspace to Nx or adds the Angular plugin to an Nx workspace. 19 ngrx : Adds NgRx support to an application or library. 20 scam-to-standalone : Convert an existing Single Component Angular Module (SCAM) to a Standalone Component. 21 scam : Generate a component with an accompanying Single Component Angular Module (SCAM). 22 scam-directive : Generate a directive with an accompanying Single Component Angular Module (SCAM). 23 scam-pipe : Generate a pipe with an accompanying Single Component Angular Module (SCAM). 24 setup-mf : Generate a Module Federation configuration for a given Angular application. 25 setup-ssr : Generate Angular Universal (SSR) setup for an Angular application. 26 setup-tailwind : Configures Tailwind CSS for an application or a buildable/publishable library. 27 stories : Creates stories/specs for all components declared in a project. 28 storybook-configuration : Adds Storybook configuration to a project. 29 cypress-component-configuration : Setup Cypress component testing for a project. 30 web-worker : Creates a Web Worker. 31 directive : Generate an Angular directive. 32 ngrx-feature-store : Adds an NgRx Feature Store to an application or library. 33 ngrx-root-store : Adds an NgRx Root Store to an application. 34 pipe : Generate an Angular Pipe 35 36 EXECUTORS/BUILDERS/ 37 38 delegate-build : Delegates the build to a different target while supporting incremental builds. 39 ... 40
Prefer a more visual UI?

If you prefer a more integrated experience, you can install the "Nx Console" extension for your code editor. It has support for VSCode, IntelliJ and ships a LSP for Vim. Nx Console provides autocompletion support in Nx configuration files and has UIs for browsing and running generators.

More info can be found in the integrate with editors article.

Run the following command to generate a new "hello-world" component. Note how we append --dry-run to first check the output.

myngapp

npx nx g @nx/angular:component hello-world --directory=src/app/hello-world --standalone --dry-run

1NX Generating @nx/angular:component 2 3CREATE src/app/hello-world/hello-world.component.css 4CREATE src/app/hello-world/hello-world.component.html 5CREATE src/app/hello-world/hello-world.component.spec.ts 6CREATE src/app/hello-world/hello-world.component.ts 7 8NOTE: The "dryRun" flag means no changes were made. 9

As you can see it generates a new component in the app/hello-world/ folder. If you want to actually run the generator, remove the --dry-run flag.

src/app/hello-world/hello-world.component.ts
1import { Component } from '@angular/core'; 2import { CommonModule } from '@angular/common'; 3 4@Component({ 5 selector: 'myngapp-hello-world', 6 standalone: true, 7 imports: [CommonModule], 8 templateUrl: './hello-world.component.html', 9 styleUrls: ['./hello-world.component.css'], 10}) 11export class HelloWorldComponent {} 12

Building the App for Deployment

If you're ready and want to ship your application, you can build it using

myngapp

npx nx build

1> nx run myngapp:build:production 2 3Browser application bundle generation complete. 4Copying assets complete. 5Index html generation complete. 6 7Initial Chunk Files | Names | Raw Size | Estimated Transfer Size 8main.afa99fe9f64fbdd9.js | main | 193.58 kB | 51.57 kB 9polyfills.1acfd3f58d94d542.js | polyfills | 32.98 kB | 10.66 kB 10runtime.37059233034b21c2.js | runtime | 892 bytes | 515 bytes 11styles.ef46db3751d8e999.css | styles | 0 bytes | - 12 13 | Initial Total | 227.44 kB | 62.73 kB 14 15Build at: 2023-05-23T14:00:31.981Z - Hash: 9086e92ce0bfefca - Time: 5228ms 16 17—————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————— 18 19Successfully ran target build for project myngapp (7s) 20

All the required files will be placed in the dist/myngapp folder and can be deployed to your favorite hosting provider.

You're ready to go!

In the previous sections you learned about the basics of using Nx, running tasks and navigating an Nx workspace. You're ready to ship features now!

But there's more to learn. You have two possibilities here:

Modularizing your Angular App with Local Libraries

When you develop your Angular application, usually all your logic sits in the app folder. Ideally separated by various folder names which represent your "domains". As your app grows, this becomes more and more monolithic though.

The following structure is a common example of this kind of monolithic code organization:

1└─ myngapp 2 ├─ ... 3 ├─ src 4 │ ├─ app 5 │ │ ├─ products 6 │ │ ├─ cart 7 │ │ ├─ ui 8 │ │ ├─ ... 9 │ │ └─ app.component.ts 10 │ ├─ ... 11 │ └─ main.ts 12 ├─ ... 13 ├─ package.json 14 ├─ ... 15

Nx allows you to separate this logic into "local libraries". The main benefits include

  • better separation of concerns
  • better reusability
  • more explicit "APIs" between your "domain areas"
  • better scalability in CI by enabling independent test/lint/build commands for each library
  • better scalability in your teams by allowing different teams to work on separate libraries

Creating Local Libraries

Let's assume our domain areas include products, orders and some more generic design system components, called ui. We can generate a new library for each of these areas using the Angular library generator:

1nx g @nx/angular:library products --directory=modules/products --standalone 2nx g @nx/angular:library orders --directory=modules/orders --standalone 3nx g @nx/angular:library shared-ui --directory=modules/shared/ui --standalone 4

Note how we use the --directory flag to place the libraries into a subfolder. You can choose whatever folder structure you like, even keep all of them at the root-level.

Running the above commands should lead to the following directory structure:

1└─ myngapp 2 ├─ ... 3 ├─ e2e/ 4 ├─ modules 5 │ ├─ products 6 │ │ ├─ .eslintrc.json 7 │ │ ├─ README.md 8 │ │ ├─ jest.config.ts 9 │ │ ├─ project.json 10 │ │ ├─ src 11 │ │ │ ├─ index.ts 12 │ │ │ ├─ lib 13 │ │ │ │ └─ products 14 │ │ │ │ ├─ products.component.css 15 │ │ │ │ ├─ products.component.html 16 │ │ │ │ ├─ products.component.spec.ts 17 │ │ │ │ └─ products.component.ts 18 │ │ │ └─ test-setup.ts 19 │ │ ├─ tsconfig.json 20 │ │ ├─ tsconfig.lib.json 21 │ │ └─ tsconfig.spec.json 22 │ ├─ orders 23 │ │ ├─ ... 24 │ │ ├─ src 25 │ │ │ ├─ index.ts 26 │ │ │ ├─ lib 27 │ │ │ │ └─ orders 28 │ │ │ │ ├─ ... 29 │ │ │ │ └─ orders.component.ts 30 │ │ ├─ ... 31 │ └─ shared 32 │ └─ ui 33 │ ├─ ... 34 │ ├─ src 35 │ │ ├─ index.ts 36 │ │ ├─ lib 37 │ │ │ └─ shared-ui 38 │ │ │ ├─ ... 39 │ │ │ └─ shared-ui.component.ts 40 │ └─ ... 41 ├─ ... 42 ├─ src 43 │ ├─ app 44 │ │ ├─ ... 45 │ │ ├─ app.component.ts 46 │ ├─ ... 47 ├─ ... 48

Each of these libraries

  • has its own project.json file with corresponding targets you can run (e.g. running tests for just orders: nx test orders)
  • has a dedicated index.ts file which is the "public API" of the library
  • is mapped in the tsconfig.base.json at the root of the workspace

Importing Libraries into the Angular Application

All libraries that we generate automatically have aliases created in the root-level tsconfig.base.json.

tsconfig.base.json
1{ 2 "compilerOptions": { 3 ... 4 "paths": { 5 "@myngapp/orders": ["modules/orders/src/index.ts"], 6 "@myngapp/products": ["modules/products/src/index.ts"], 7 "@myngapp/shared-ui": ["modules/shared/ui/src/index.ts"] 8 }, 9 ... 10 }, 11} 12

Hence we can easily import them into other libraries and our Angular application. For example: let's use our existing ProductsComponent in modules/products/src/lib/products/:

1import { Component } from '@angular/core'; 2import { CommonModule } from '@angular/common'; 3 4@Component({ 5 selector: 'myngapp-products', 6 standalone: true, 7 imports: [CommonModule], 8 templateUrl: './products.component.html', 9 styleUrl: './products.component.css', 10}) 11export class ProductsComponent {} 12

Make sure the ProductsComponent is exported via the index.ts file of our products library (which it should already be). The modules/products/src/index.ts file is the public API for the products library with the rest of the workspace. Only export what's really necessary to be usable outside the library itself.

modules/products/src/index.ts
1export * from './lib/products/products.component'; 2

We're ready to import it into our main application now. If you opted into generating a router configuration when setting up the Nx workspace initially, you should have an app.routes.ts file in your app folder. If not, create it and configure the Angular router.

Configure the routing as follows:

src/app/app.routes.ts
1import { Route } from '@angular/router'; 2import { NxWelcomeComponent } from './nx-welcome.component'; 3 4export const appRoutes: Route[] = [ 5 { 6 path: '', 7 component: NxWelcomeComponent, 8 pathMatch: 'full', 9 }, 10 { 11 path: 'products', 12 loadComponent: () => 13 import('@myngapp/products').then((m) => m.ProductsComponent), 14 }, 15]; 16

As part of this step, we should also remove the NxWelcomeComponent from the AppComponent.imports declaration so that it is just loaded over the routing mechanism. The app.component.html should just have the <router-outlet> left:

src/app/app.component.html
1<router-outlet></router-outlet> 2

If you now navigate to http://localhost:4200/products you should see the ProductsComponent being rendered.

Browser screenshot of navigating to the products route

Let's do the same process for our orders library. Import the OrdersComponent into the app.routes.ts:

src/app/app.routes.ts
1import { Route } from '@angular/router'; 2import { NxWelcomeComponent } from './nx-welcome.component'; 3 4export const appRoutes: Route[] = [ 5 { 6 path: '', 7 component: NxWelcomeComponent, 8 pathMatch: 'full', 9 }, 10 { 11 path: 'products', 12 loadComponent: () => 13 import('@myngapp/products').then((m) => m.ProductsComponent), 14 }, 15 { 16 path: 'orders', 17 loadComponent: () => 18 import('@myngapp/orders').then((m) => m.OrdersComponent), 19 }, 20]; 21

Similarly, navigating to http://localhost:4200/orders should now render the OrdersComponent.

A couple of notes:

  • both the ProductsComponent and OrdersComponent are lazy loaded
  • you could go even further and configure routes within the libraries and only import and attach those routes to the application routing mechanism.

Visualizing your Project Structure

Nx automatically detects the dependencies between the various parts of your workspace and builds a project graph. This graph is used by Nx to perform various optimizations such as determining the correct order of execution when running tasks like nx build, identifying affected projects and more. Interestingly you can also visualize it.

Just run:

nx graph

You should be able to see something similar to the following in your browser (hint: click the "Show all projects" button).

Loading...

Notice how shared-ui is not yet connected to anything because we didn't import it in any of our projects. Also the arrows to orders and products are dashed because we're using lazy imports.

Exercise for you: change the codebase so that shared-ui is used by orders and products. Note: you need to restart the nx graph command to update the graph visualization or run the CLI command with the --watch flag.

Imposing Constraints with Module Boundary Rules

Once you modularize your codebase you want to make sure that the modules are not coupled to each other in an uncontrolled way. Here are some examples of how we might want to guard our small demo workspace:

  • we might want to allow orders to import from shared-ui but not the other way around
  • we might want to allow orders to import from products but not the other way around
  • we might want to allow all libraries to import the shared-ui components, but not the other way around

When building these kinds of constraints you usually have two dimensions:

  • type of project: what is the type of your library. Example: "feature" library, "utility" library, "data-access" library, "ui" library (see library types)
  • scope (domain) of the project: what domain area is covered by the project. Example: "orders", "products", "shared" ... this really depends on the type of product you're developing

Nx comes with a generic mechanism that allows you to assign "tags" to projects. "tags" are arbitrary strings you can assign to a project that can be used later when defining boundaries between projects. For example, go to the project.json of your orders library and assign the tags type:feature and scope:orders to it.

modules/orders/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:orders"], 4 ... 5} 6

Then go to the project.json of your products library and assign the tags type:feature and scope:products to it.

modules/products/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:products"], 4 ... 5} 6

Finally, go to the project.json of the shared-ui library and assign the tags type:ui and scope:shared to it.

modules/shared/ui/project.json
1{ 2 ... 3 "tags": ["type:ui", "scope:shared"], 4 ... 5} 6

Notice how we assign scope:shared to our UI library because it is intended to be used throughout the workspace.

Next, let's come up with a set of rules based on these tags:

  • type:feature should be able to import from type:feature and type:ui
  • type:ui should only be able to import from type:ui
  • scope:orders should be able to import from scope:orders, scope:shared and scope:products
  • scope:products should be able to import from scope:products and scope:shared

To enforce the rules, Nx ships with a custom ESLint rule. Open the .eslintrc.base.json at the root of the workspace and add the following depConstraints in the @nx/enforce-module-boundaries rule configuration:

.eslintrc.base.json
1{ 2 ... 3 "overrides": [ 4 { 5 ... 6 "rules": { 7 "@nx/enforce-module-boundaries": [ 8 "error", 9 { 10 "enforceBuildableLibDependency": true, 11 "allow": [], 12 "depConstraints": [ 13 { 14 "sourceTag": "*", 15 "onlyDependOnLibsWithTags": ["*"] 16 }, 17 { 18 "sourceTag": "type:feature", 19 "onlyDependOnLibsWithTags": ["type:feature", "type:ui"] 20 }, 21 { 22 "sourceTag": "type:ui", 23 "onlyDependOnLibsWithTags": ["type:ui"] 24 }, 25 { 26 "sourceTag": "scope:orders", 27 "onlyDependOnLibsWithTags": [ 28 "scope:orders", 29 "scope:products", 30 "scope:shared" 31 ] 32 }, 33 { 34 "sourceTag": "scope:products", 35 "onlyDependOnLibsWithTags": ["scope:products", "scope:shared"] 36 }, 37 { 38 "sourceTag": "scope:shared", 39 "onlyDependOnLibsWithTags": ["scope:shared"] 40 } 41 ] 42 } 43 ] 44 } 45 }, 46 ... 47 ] 48} 49

To test it, go to your modules/products/src/lib/products/products.component.ts file and import the OrderComponent from the orders project:

modules/products/src/lib/products/products.component.ts
1import { Component } from '@angular/core'; 2import { CommonModule } from '@angular/common'; 3 4// 👇 this import is not allowed 5import { OrdersComponent } from '@myngapp/orders'; 6 7@Component({ 8 selector: 'myngapp-products', 9 standalone: true, 10 imports: [CommonModule, OrdersComponent], 11 templateUrl: './products.component.html', 12 styleUrls: ['./products.component.css'], 13}) 14export class ProductsComponent {} 15

If you lint your workspace you'll get an error now:

nx run-many -t lint

1✖ nx run products:lint 2 Linting "products"... 3 4 /Users/juri/nrwl/content/myngapp/modules/products/src/lib/products/products.component.ts 5 3:1 error A project tagged with "scope:products" can only depend on libs tagged with "scope:products", "scope:shared" @nx/enforce-module-boundaries 6 7 ✖ 1 problem (1 error, 0 warnings) 8 9 Lint errors found in the listed files. 10 11✔ nx run orders:lint (1s) 12✔ nx run myngapp:lint (1s) 13✔ nx run e2e:lint (682ms) 14✔ nx run shared-ui:lint (797ms) 15 16————————————————————————————————————————————————————————————————————— 17 18NX Ran target lint for 5 projects (2s) 19 20✔ 4/5 succeeded [0 read from cache] 21 22✖ 1/5 targets failed, including the following: 23 - nx run products:lint 24 25

If you have the ESLint plugin installed in your IDE you should immediately see an error:

ESLint module boundary error

Learn more about how to enforce module boundaries.

Migrating to a Monorepo

When you are ready to add another application to the repo, you'll probably want to move myngapp to its own folder. To do this, you can run the convert-to-monorepo generator or manually move the configuration files.

You can also go through the full Angular monorepo tutorial

Fast CI ⚡

Repository with Nx

Make sure you have completed the previous sections of this tutorial before starting this one. If you want a clean starting point, you can check out the reference code as a starting point.

This tutorial walked you through how Nx can improve the local development experience, but the biggest difference Nx makes is in CI. As repositories get bigger, making sure that the CI is fast, reliable and maintainable can get very challenging. Nx provides a solution.

Connect to Nx Cloud

Nx Cloud is a companion app for your CI system that provides remote caching, task distribution, e2e tests deflaking, better DX and more.

Now that we're working on the CI pipeline, it is important for your changes to be pushed to a GitHub repository.

  1. Commit your existing changes with git add . && git commit -am "updates"
  2. Create a new GitHub repository
  3. Follow GitHub's instructions to push your existing code to the repository

When we set up the repository at the beginning of this tutorial, we chose to use GitHub Actions as a CI provider. This created a basic CI pipeline and configured Nx Cloud in the repository. It also printed a URL in the terminal to register your repository in your Nx Cloud account. If you didn't click on the link when first creating your repository, you can show it again by running:

npx nx connect

Once you click the link, follow the steps provided and make sure Nx Cloud is enabled on the main branch of your repository.

Configure Your CI Workflow

When you chose GitHub Actions as your CI provider at the beginning of the tutorial, create-nx-workspace created a .github/workflows/ci.yml file that contains a CI pipeline that will run the lint, test, build and e2e tasks for projects that are affected by any given PR. Since we are using Nx Cloud, the pipeline will also distribute tasks across multiple machines to ensure fast and reliable CI runs.

If you need to generate a new workflow file for GitHub Actions or other providers, you can do so with this command:

npx nx generate ci-workflow

The key lines in the CI pipeline are:

.github/workflows/ci.yml
1name: CI 2# ... 3jobs: 4 main: 5 runs-on: ubuntu-latest 6 steps: 7 - uses: actions/checkout@v4 8 with: 9 fetch-depth: 0 10 # This enables task distribution via Nx Cloud 11 # Run this command as early as possible, before dependencies are installed 12 # Learn more at https://nx.dev/ci/reference/nx-cloud-cli#npx-nxcloud-startcirun 13 # Connect your workspace by running "nx connect" and uncomment this 14 - run: npx nx-cloud start-ci-run --distribute-on="3 linux-medium-js" --stop-agents-after="build" 15 - uses: actions/setup-node@v3 16 with: 17 node-version: 20 18 cache: 'npm' 19 - run: npm ci --legacy-peer-deps 20 - uses: nrwl/nx-set-shas@v4 21 # Nx Affected runs only tasks affected by the changes in this PR/commit. Learn more: https://nx.dev/ci/features/affected 22 - run: npx nx affected -t lint test build 23

Open a Pull Request

Commit the changes and open a new PR on GitHub.

git add .

git commit -m 'add CI workflow file'

git push origin add-workflow

When you view the PR on GitHub, you will see a comment from Nx Cloud that reports on the status of the CI run.

Nx Cloud report

The See all runs link goes to a page with the progress and results of tasks that were run in the CI pipeline.

Run details

For more information about how Nx can improve your CI pipeline, check out one of these detailed tutorials:

Next Steps

Here's some things you can dive into next:

Also, make sure you

Building a Single Vue App with Nx

In this tutorial you'll learn how to use Vue with Nx in a "standalone" (non-monorepo) setup. Not to be confused with the "Vue Standalone API", a standalone project in Nx is a non-monorepo setup where you have a single application at the root level.

What will you learn?

  • how to add Nx to a Vue project
  • how to run a single task (i.e. serve your app) or run multiple tasks in parallel
  • how to leverage code generators to scaffold components
  • how to modularize your codebase and impose architectural constraints for better maintainability
  • how to speed up CI with Nx Cloud ⚡

We'll start out this tutorial using Nx together with a Vue application generated with the default npm create vue command. Later, we'll add the @nx/vue plugin to show the nice enhancements that it can provide. Visit our "Why Nx" page to learn more about plugins and what role they play in the Nx architecture.

Final Code

Here's the source code of the final result for this tutorial.

Creating a new Vue App

Create a new Vue application with the following command:

~

npm create vue vue-app -- --ts --jsx --router --vitest --playwright --eslint-with-prettier

1 2Vue.js - The Progressive JavaScript Framework 3 4Scaffolding project in ~/vue-app... 5 6Done. Now run: 7 8 cd vue-app 9 npm install 10 npm run format 11 npm run dev 12

Once you have run npm install, set up Git with the following commands:

git init

git add .

git commit -m "initial commit"

This command sets up a Vue app that uses Typescript and is configured to use the Vue router, Vitest for unit tests, Playwright for e2e tests and ESLint and Prettier for formatting. Your repository should now have the following structure:

1└─ vue-app 2 ├─ .vscode 3 │ └─ extensions.json 4 ├─ e2e 5 │ ├─ tsconfig.json 6 │ └─ vue.spec.ts 7 ├─ public 8 ├─ src 9 │ ├─ assets 10 │ ├─ components 11 │ ├─ router 12 │ ├─ views 13 │ ├─ App.vue 14 │ └─ main.ts 15 ├─ .eslintrc.cjs 16 ├─ .prettierrc.json 17 ├─ index.html 18 ├─ package.json 19 ├─ playwright.config.ts 20 ├─ README.md 21 ├─ tsconfig.app.json 22 ├─ tsconfig.json 23 ├─ tsconfig.node.json 24 ├─ tsconfig.vitest.json 25 ├─ vite.config.ts 26 └─ vitest.config.ts 27

The setup includes..

  • a new Vue application at the root of the Nx workspace (src)
  • a Playwright based set of e2e tests (e2e/)
  • Prettier preconfigured
  • ESLint preconfigured
  • Vitest preconfigured

You can build the application with the following command:

1npm run build 2

Add Nx

Nx offers many features, but at its core, it is a task runner. Out of the box, it can:

After the initial set up, you can incrementally add on other features that would be helpful in your organization.

To enable Nx in your repository, run a single command:

npx nx@latest init

This command will download the latest version of Nx and help set up your repository to take advantage of it.

First, the script will propose installing some plugins based on the packages that are being used in your repository.

  • Leave the plugins deselected so that we can explore what Nx provides without any plugins.

Second, the script asks a series of questions to help set up caching for you.

  • Which scripts are cacheable? - Choose test:e2e, build-only, type-check and lint
  • Does the "test:e2e" script create any outputs? - Enter playwright-report
  • Does the "build-only" script create any outputs? - Enter dist
  • Does the "type-check" script create any outputs? - Enter nothing
  • Does the "lint" script create any outputs? - Enter nothing
  • Would you like remote caching to make your build faster? - Choose Skip for now.

We'll enable Nx Cloud and add remote caching later in the tutorial.

Caching Pre-configured

Nx has been configured to run your npm scripts as Nx tasks. You can run a single task like this:

npx nx type-check vue-app

During the init script, Nx also configured caching for these tasks. You can see in the nx.json file that the scripts we identified as cacheable have the cache property set to true and the build-only target specifies that its output goes to the project's dist folder.

nx.json
1{ 2 "$schema": "./node_modules/nx/schemas/nx-schema.json", 3 "targetDefaults": { 4 "test:e2e": { 5 "outputs": ["{projectRoot}/playwright-report"], 6 "cache": true 7 }, 8 "build-only": { 9 "outputs": ["{projectRoot}/dist"], 10 "cache": true 11 }, 12 "type-check": { 13 "cache": true 14 }, 15 "lint": { 16 "cache": true 17 } 18 }, 19 "defaultBase": "main" 20} 21

Try running type-check for the vue-app app a second time:

npx nx type-check vue-app

The first time nx type-check was run, it took about 2 seconds - just like running npm run type-check. But the second time you run nx type-check, it completes instantly and displays this message:

1Nx read the output from the cache instead of running the command for 1 out of 1 tasks. 2

You can see the same caching behavior working when you run npx nx lint.

Create a Task Pipeline

If you look at the build script in package.json, you'll notice that it is actually doing two things. It runs the type-check script and, in parallel, runs the build-only script.

package.json
1{ 2 "scripts": { 3 "build": "run-p type-check \"build-only {@}\" --", 4 "build-only": "vite build", 5 "type-check": "vue-tsc --build --force" 6 } 7} 8

Instead of deciding ahead of time whether tasks need to be run in parallel or series, let's define the dependencies between tasks and then allow Nx to run them in the most efficient way possible. Update the package.json file with the following information:

package.json
1{ 2 "scripts": { 3 "build": "nx exec -- echo 'Ran type-check and build-only'", 4 "build-only": "vite build", 5 "type-check": "vue-tsc --build --force" 6 } 7} 8

Since the build command itself doesn't do anything, we can replace it with an echo to the console. The dependencies between the tasks we can define in the dependsOn property in the nx.json file:

nx.json
1{ 2 "targetDefaults": { 3 "build": { 4 "dependsOn": ["type-check", "build-only"] 5 } 6 } 7} 8

Whenever Nx runs the build task, it knows that the type-check and build-only tasks need to be run first. However, if the build script is run without using Nx (say with npm run build), the task dependencies will not be run. That's why we add the nx exec -- command at the beginning of the build script in package.json. If you run npm run build, Nx will be used to run the task and any dependencies will be invoked correctly.

Now if you run nx build vue-app, Nx will run type-check and build-only first.

There's still one piece of functionality that was lost by this change. The {@} syntax in the original build script was used to forward command line arguments to the build-only script. To accomplish the same thing with Nx, instead of using a string for the build-only task dependency, we'll use an object and tell Nx to forward arguments on to that task.

nx.json
1{ 2 "targetDefaults": { 3 "build": { 4 "dependsOn": [ 5 "type-check", 6 { 7 "target": "build-only", 8 "params": "forward" 9 } 10 ] 11 } 12 } 13} 14

If you run nx build vue-app -l=error, Nx will run the build-only script with a log level of error.

~/vue-app

npx nx build

1> nx run vue-app:type-check [existing outputs match the cache, left as is] 2 3 4> vue-app@0.0.0 type-check 5> vue-tsc --build --force 6 7 8> nx run vue-app:build-only [local cache] 9 10 11> vue-app@0.0.0 build-only 12> vite build -l error 13 14 15> nx run vue-app:build -l error 16 17 18> vue-app@0.0.0 build 19> nx exec -- echo 'Ran type-check and build-only' -l error 20 21Ran type-check and build-only -l error 22 23————————————————————————————————————————————————————————————————————— 24 25 NX Successfully ran target build for project vue-app and 2 tasks it depends on (456ms) 26 27 With additional flags: 28 --l=error 29

And once again, running npx nx build or npm run build twice will complete instantly.

Use Nx Plugins to Enhance Vite Tasks with Caching

You may remember that we defined the outputs property in nx.json when we were answering questions in the nx init script. The value is currently hard-coded so that if you change the output path in your vite.config.ts, you have to remember to also change the outputs array in the build task configuration. This is where plugins can help. Plugins enable better integration with specific tools. The @nx/vite plugin can understand the vite.config.ts file and automatically create and configure tasks based on the settings in that file.

Nx plugins can:

  • automatically configure caching for you, including inputs and outputs based on the underlying tooling configuration
  • create tasks for a project using the tooling configuration files
  • provide code generators to help scaffold out projects
  • automatically keep the tooling versions and configuration files up to date

For this tutorial, we'll just focus on the automatic caching configuration.

First, let's delete the outputs array for the build-only task in nx.json so that we don't override the inferred values from the plugin. Your nx.json should look like this:

nx.json
1{ 2 "$schema": "./node_modules/nx/schemas/nx-schema.json", 3 "targetDefaults": { 4 "test:e2e": { 5 "outputs": ["{projectRoot}/playwright-report"], 6 "cache": true 7 }, 8 "build": { 9 "dependsOn": [ 10 "type-check", 11 { 12 "target": "build-only", 13 "params": "forward" 14 } 15 ] 16 }, 17 "build-only": { 18 "cache": true 19 }, 20 "type-check": { 21 "cache": true 22 }, 23 "lint": { 24 "cache": true 25 } 26 }, 27 "defaultBase": "main" 28} 29

Now let's add the @nx/vite plugin:

~/vue-app

npx nx add @nx/vite

1✔ Installing @nx/vite... 2✔ Initializing @nx/vite... 3 4 NX Package @nx/vite added successfully. 5

The nx add command installs the version of the plugin that matches your repo's Nx version and runs that plugin's initialization script. For @nx/vite, the initialization script registers the plugin in the plugins array of nx.json and updates any package.json scripts that execute Vite related tasks. Open the project details view for the vue-app app and look at the vite:build task.

npx nx show project vue-app

Loading...

If you hover over the settings for the vite:build task, you can see where those settings come from. The inputs and outputs are defined by the @nx/vite plugin from the vite.config.ts file where as the dependsOn property we set earlier in the tutorial is set in the targetDefaults in the nx.json file.

Now let's change where the vite:build results are output to in the vite.config.ts file.

vite.config.ts
1import { fileURLToPath, URL } from 'node:url' 2 3import { defineConfig } from 'vite' 4import vue from '@vitejs/plugin-vue' 5import vueJsx from '@vitejs/plugin-vue-jsx' 6 7// https://vitejs.dev/config/ 8export default defineConfig({ 9 plugins: [vue(), vueJsx()], 10 build: { 11 outDir: 'dist/vue-app' 12 }, 13 resolve: { 14 alias: { 15 '@': fileURLToPath(new URL('./src', import.meta.url)) 16 } 17 } 18}) 19

Now if you look at project details view again, you'll see that the outputs property for Nx's caching has been updated to stay in sync with the setting in the vite.config.ts file.

You can also add the @nx/eslint plugin to see how it infers lint tasks based on the ESLint configuration files.

1npx nx add @nx/eslint 2

Creating New Components

You can just create new Vue components as you normally would. However, Nx plugins also ship generators. They allow you to easily scaffold code, configuration or entire projects. Let's add the @nx/vue plugin to take advantage of the generators it provides.

1npx nx add @nx/vue 2

To see what capabilities the @nx/vue plugin ships, run the following command and inspect the output:

~/vue-app

npx nx list @nx/vue

1 2NX Capabilities in @nx/vue: 3 4 GENERATORS 5 6 init : Initialize the `@nx/vue` plugin. 7 application : Create a Vue application. 8 library : Create a Vue library. 9 component : Create a Vue component. 10 setup-tailwind : Set up Tailwind configuration for a project. 11 storybook-configuration : Set up storybook for a Vue app or library. 12 stories : Create stories for all components declared in an app or library. 13
Prefer a more visual UI?

If you prefer a more integrated experience, you can install the "Nx Console" extension for your code editor. It has support for VSCode, IntelliJ and ships a LSP for Vim. Nx Console provides autocompletion support in Nx configuration files and has UIs for browsing and running generators.

More info can be found in the editor setup page.

Run the following command to generate a new "BaseButton" component. Note how we append --dry-run to first check the output.

~/vue-app

npx nx g @nx/vue:component BaseButton --no-export --skipTests --directory=src/components --dry-run

1 NX Generating @nx/vue:component 2 3✔ Where should the component be generated? · src/components/BaseButton.vue 4CREATE src/components/BaseButton.vue 5 6NOTE: The "dryRun" flag means no changes were made. 7

As you can see it generates a new component in the src/components/ folder. If you want to actually run the generator, remove the --dry-run flag.

src/components/BaseButton.vue
1<script setup lang="ts"> 2// defineProps<{}>() 3</script> 4 5<template> 6 <p>Welcome to BaseButton!</p> 7</template> 8 9<style scoped></style> 10

You're ready to go!

In the previous sections you learned about the basics of using Nx, running tasks and navigating an Nx workspace. You're ready to ship features now!

But there's more to learn. You have two possibilities here:

Modularize your Vue App with Local Libraries

When you develop your Vue application, usually all your logic sits in the src folder. Ideally separated by various folder names which represent your "domains". As your app grows, this becomes more and more monolithic though.

1└─ vue-app 2 ├─ ... 3 ├─ src 4 │ ├─ views 5 │ │ ├─ products 6 │ │ └─ cart 7 │ ├─ components 8 │ │ ├─ ui 9 │ │ └─ ... 10 │ ├─ App.vue 11 │ └─ main.ts 12 ├─ ... 13 ├─ package.json 14 ├─ ... 15

Nx allows you to separate this logic into "local libraries". The main benefits include

  • better separation of concerns
  • better reusability
  • more explicit "APIs" between your "domain areas"
  • better scalability in CI by enabling independent test/lint/build commands for each library
  • better scalability in your teams by allowing different teams to work on separate libraries

Create a Local Library

Let's assume our domain areas include products, orders and some more generic design system components, called ui. We can generate a new library for these areas using the Vue library generator:

1nx g @nx/vue:library products --unitTestRunner=vitest --bundler=vite --directory=modules/products --component 2

Note how we use the --directory flag to place the library into a subfolder. You can choose whatever folder structure you like to organize your libraries.

Nx tries to set up your workspace to work with the modular library architecture, but depending on your existing configuration, you may need to tweak some settings. In this repo, you'll need to do a few things in order to prepare for future steps.

Lint Settings

We want the lint task for the root vue-app project to only lint the files for that project, so we'll change the lint command in package.json:

package.json
1{ 2 "scripts": { 3 "lint": "eslint src --ext .vue,.js,.jsx,.cjs,.mjs,.ts,.tsx,.cts,.mts --fix --ignore-path .gitignore" 4 } 5} 6

Now we need to update the .eslintrc.cjs file to extend the .eslintrc.base.json file:

.eslintrc.cjs
1/* eslint-env node */ 2require('@rushstack/eslint-patch/modern-module-resolution'); 3 4module.exports = { 5 root: true, 6 extends: [ 7 'plugin:vue/vue3-essential', 8 'eslint:recommended', 9 '@vue/eslint-config-typescript', 10 '@vue/eslint-config-prettier/skip-formatting', 11 './.eslintrc.base.json', 12 ], 13 ignorePatterns: ['!**/*'], 14 overrides: [ 15 { 16 files: ['e2e/**/*.{test,spec}.{js,ts,jsx,tsx}'], 17 extends: ['plugin:playwright/recommended'], 18 }, 19 ], 20 parserOptions: { 21 ecmaVersion: 'latest', 22 }, 23}; 24

Build Settings

To make sure that the build can correctly pull in code from libraries, we need to move the typescript paths from the tsconfig.app.json file to the newly created tsconfig.base.json and extend that base file.

tsconfig.app.json
1{ 2 "extends": ["@vue/tsconfig/tsconfig.dom.json", "./tsconfig.base.json"], 3 "include": ["env.d.ts", "src/**/*", "src/**/*.vue"], 4 "exclude": ["src/**/__tests__/*"] 5} 6
tsconfig.vitest.json
1{ 2 "extends": "./tsconfig.app.json", 3 "exclude": [], 4 "compilerOptions": { 5 "lib": [], 6 "types": ["node", "jsdom"] 7 } 8} 9
tsconfig.base.json
1{ 2 "compileOnSave": false, 3 "compilerOptions": { 4 "baseUrl": ".", 5 "paths": { 6 "@/*": ["./src/*"], 7 "products": ["modules/products/src/index.ts"] 8 } 9 } 10} 11

We also need to update vite.config.ts to account for typescript aliases. Run the following generator to automatically update your configuration file.

npx nx g @nx/vite:setup-paths-plugin

This will update the vite.config.ts file to include the nxViteTsPaths plugin in the plugins array.

vite.config.ts
1import { fileURLToPath, URL } from 'node:url'; 2 3import { defineConfig } from 'vite'; 4import vue from '@vitejs/plugin-vue'; 5import vueJsx from '@vitejs/plugin-vue-jsx'; 6import { nxViteTsPaths } from '@nx/vite/plugins/nx-tsconfig-paths.plugin'; 7 8// https://vitejs.dev/config/ 9export default defineConfig({ 10 plugins: [vue(), vueJsx(), nxViteTsPaths()], 11 build: { 12 outDir: 'dist/vue-app', 13 }, 14 resolve: { 15 alias: { 16 '@': fileURLToPath(new URL('./src', import.meta.url)), 17 }, 18 }, 19}); 20

Create More Libraries

Now that the repository is set up, let's generate the orders and ui libraries.

1nx g @nx/vue:library orders --unitTestRunner=vitest --bundler=vite --directory=modules/orders --component 2nx g @nx/vue:library ui --unitTestRunner=vitest --bundler=vite --directory=modules/shared/ui --component 3

Running the above commands should lead to the following directory structure:

1└─ vue-app 2 ├─ ... 3 ├─ e2e/ 4 ├─ modules 5 │ ├─ products 6 │ │ ├─ .eslintrc.json 7 │ │ ├─ README.md 8 │ │ ├─ vite.config.ts 9 │ │ ├─ package.json 10 │ │ ├─ project.json 11 │ │ ├─ src 12 │ │ │ ├─ index.ts 13 │ │ │ └─ lib 14 │ │ │ ├─ products.spec.ts 15 │ │ │ └─ products.vue 16 │ │ ├─ tsconfig.json 17 │ │ ├─ tsconfig.lib.json 18 │ │ ├─ tsconfig.spec.json 19 │ │ └─ vite.config.ts 20 │ ├─ orders 21 │ │ ├─ ... 22 │ │ ├─ project.json 23 │ │ ├─ src 24 │ │ │ ├─ index.ts 25 │ │ │ └─ ... 26 │ │ └─ ... 27 │ └─ shared 28 │ └─ ui 29 │ ├─ ... 30 │ ├─ project.json 31 │ ├─ src 32 │ │ ├─ index.ts 33 │ │ └─ ... 34 │ └─ ... 35 ├─ src 36 │ ├─ components 37 │ ├─ ... 38 │ ├─ App.vue 39 │ └─ main.tsx 40 ├─ ... 41

Each of these libraries

  • has a project details view where you can see the available tasks (e.g. running tests for just orders: nx test orders)
  • has its own project.json file where you can customize targets
  • has a dedicated index.ts file which is the "public API" of the library
  • is mapped in the tsconfig.base.json at the root of the workspace

Importing Libraries into the Vue Application

All libraries that we generate automatically have aliases created in the root-level tsconfig.base.json.

tsconfig.base.json
1{ 2 "compilerOptions": { 3 ... 4 "paths": { 5 "@/*": ["./src/*"], 6 "orders": ["modules/orders/src/index.ts"], 7 "products": ["modules/products/src/index.ts"], 8 "ui": ["modules/shared/ui/src/index.ts"] 9 }, 10 ... 11 }, 12} 13

That way we can easily import them into other libraries and our Vue application. As an example, let's import the Products component from the products project into our main application. First, configure the router in the src/router/index.ts.

src/router/index.ts
1import { createRouter, createWebHistory } from 'vue-router'; 2import HomeView from '../views/HomeView.vue'; 3 4const router = createRouter({ 5 history: createWebHistory(import.meta.env.BASE_URL), 6 routes: [ 7 { 8 path: '/', 9 name: 'home', 10 component: HomeView, 11 }, 12 { 13 path: '/about', 14 name: 'about', 15 // route level code-splitting 16 // this generates a separate chunk (About.[hash].js) for this route 17 // which is lazy-loaded when the route is visited. 18 component: () => import('../views/AboutView.vue'), 19 }, 20 { 21 path: '/products', 22 name: 'products', 23 component: () => import('products').then((m) => m.Products), 24 }, 25 { 26 path: '/orders', 27 name: 'orders', 28 component: () => import('orders').then((m) => m.Orders), 29 }, 30 ], 31}); 32 33export default router; 34

Then we can add links to the routes in App.vue.

src/App.vue
1<script setup lang="ts"> 2import { RouterLink, RouterView } from 'vue-router' 3import HelloWorld from './components/HelloWorld.vue' 4</script> 5 6<template> 7 <header> 8 <img alt="Vue logo" class="logo" src="@/assets/logo.svg" width="125" height="125" /> 9 10 <div class="wrapper"> 11 <HelloWorld msg="You did it!" /> 12 13 <nav> 14 <RouterLink to="/">Home</RouterLink> 15 <RouterLink to="/about">About</RouterLink> 16 <RouterLink to="/products">Products</RouterLink> 17 <RouterLink to="/orders">Orders</RouterLink> 18 </nav> 19 </div> 20 </header> 21 22 <RouterView /> 23</template> 24 25... 26

Serving your app (nx serve) and then navigating to /products should give you the following result:

products route

Visualizing your Project Structure

Nx automatically detects the dependencies between the various parts of your workspace and builds a project graph. This graph is used by Nx to perform various optimizations such as determining the correct order of execution when running tasks like nx build, identifying affected projects and more. Interestingly you can also visualize it.

Just run:

nx graph

You should be able to see something similar to the following in your browser (hint: click the "Show all projects" button).

Loading...

Notice how ui is not yet connected to anything because we didn't import it in any of our projects. Also the arrows to orders and products are dashed because we're using lazy imports.

Exercise for you: change the codebase so that ui is used by orders and products.

Imposing Constraints with Module Boundary Rules

Once you modularize your codebase you want to make sure that the modules are not coupled to each other in an uncontrolled way. Here are some examples of how we might want to guard our small demo workspace:

  • we might want to allow orders to import from shared-ui but not the other way around
  • we might want to allow orders to import from products but not the other way around
  • we might want to allow all libraries to import the shared-ui components, but not the other way around

When building these kinds of constraints you usually have two dimensions:

  • type of project: what is the type of your library. Example: "feature" library, "utility" library, "data-access" library, "ui" library (see library types)
  • scope (domain) of the project: what domain area is covered by the project. Example: "orders", "products", "shared" ... this really depends on the type of product you're developing

Nx comes with a generic mechanism that allows you to assign "tags" to projects. "tags" are arbitrary strings you can assign to a project that can be used later when defining boundaries between projects. For example, go to the project.json of your orders library and assign the tags type:feature and scope:orders to it.

modules/orders/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:orders"], 4 ... 5} 6

Then go to the project.json of your products library and assign the tags type:feature and scope:products to it.

modules/products/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:products"], 4 ... 5} 6

Finally, go to the project.json of the shared-ui library and assign the tags type:ui and scope:shared to it.

modules/shared/ui/project.json
1{ 2 ... 3 "tags": ["type:ui", "scope:shared"], 4 ... 5} 6

Notice how we assign scope:shared to our UI library because it is intended to be used throughout the workspace.

Next, let's come up with a set of rules based on these tags:

  • type:feature should be able to import from type:feature and type:ui
  • type:ui should only be able to import from type:ui
  • scope:orders should be able to import from scope:orders, scope:shared and scope:products
  • scope:products should be able to import from scope:products and scope:shared

To enforce the rules, Nx ships with a custom ESLint rule.

Lint Settings

We want the lint task for the root react-app project to only lint the files for that project (in the src folder), so we'll change the lint command in package.json:

package.json
1{ 2 "scripts": { 3 "lint": "eslint src --ext .vue,.js,.jsx,.cjs,.mjs,.ts,.tsx,.cts,.mts --fix --ignore-path .gitignore" 4 } 5} 6

We need to update the .eslintrc.cjs file to extend the .eslintrc.base.json file and undo the ignorePattern from that config that ignores every file. The .eslintrc.base.json file serves as a common set of lint rules for every project in the repository.

.eslintrc.cjs
1/* eslint-env node */ 2require('@rushstack/eslint-patch/modern-module-resolution'); 3 4module.exports = { 5 root: true, 6 extends: [ 7 'plugin:vue/vue3-essential', 8 'eslint:recommended', 9 '@vue/eslint-config-typescript', 10 '@vue/eslint-config-prettier/skip-formatting', 11 './.eslintrc.base.json', 12 ], 13 ignorePatterns: ['!**/*'], 14 overrides: [ 15 { 16 files: ['e2e/**/*.{test,spec}.{js,ts,jsx,tsx}'], 17 extends: ['plugin:playwright/recommended'], 18 }, 19 ], 20 parserOptions: { 21 ecmaVersion: 'latest', 22 }, 23}; 24

Now we need to update the .eslintrc.base.json file and define the depConstraints in the @nx/enforce-module-boundaries rule:

.eslintrc.base.json
1{ 2 "overrides": [ 3 { 4 "files": ["*.ts", "*.tsx", "*.js", "*.jsx"], 5 "rules": { 6 "@nx/enforce-module-boundaries": [ 7 "error", 8 { 9 "enforceBuildableLibDependency": true, 10 "allow": [], 11 "depConstraints": [ 12 { 13 "sourceTag": "*", 14 "onlyDependOnLibsWithTags": ["*"] 15 }, 16 { 17 "sourceTag": "type:feature", 18 "onlyDependOnLibsWithTags": ["type:feature", "type:ui"] 19 }, 20 { 21 "sourceTag": "type:ui", 22 "onlyDependOnLibsWithTags": ["type:ui"] 23 }, 24 { 25 "sourceTag": "scope:orders", 26 "onlyDependOnLibsWithTags": [ 27 "scope:orders", 28 "scope:products", 29 "scope:shared" 30 ] 31 }, 32 { 33 "sourceTag": "scope:products", 34 "onlyDependOnLibsWithTags": ["scope:products", "scope:shared"] 35 }, 36 { 37 "sourceTag": "scope:shared", 38 "onlyDependOnLibsWithTags": ["scope:shared"] 39 } 40 ] 41 } 42 ] 43 } 44 } 45 ... 46 ] 47} 48

When Nx set up the @nx/eslint plugin, it chose a task name that would not conflict with the pre-existing lint script. Let's overwrite that name so that all the linting tasks use the same lint name. Update the setting in the nx.json file:

nx.json
1{ 2 ... 3 "plugins": [ 4 { 5 "plugin": "@nx/eslint/plugin", 6 "options": { 7 "targetName": "lint" 8 } 9 } 10 ] 11} 12

Test Boundary Rules

To test the boundary rules, go to your modules/products/src/lib/products.tsx file and import the Orders from the orders project:

To test it, go to your modules/products/src/lib/products.vue file and import the Orders component from the orders project:

modules/products/src/lib/products.vue
1<script setup lang="ts"> 2defineProps<{}>(); 3 4// 👇 this import is not allowed 5import { Orders } from 'orders'; 6</script> 7 8<template> 9 <p>Welcome to Products!</p> 10</template> 11 12<style scoped></style> 13

If you lint your workspace you'll get an error now:

nx run-many -t lint

1 ✔ nx run ui:lint [existing outputs match the cache, left as is] 2 ✔ nx run orders:lint [existing outputs match the cache, left as is] 3 4—————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————— 5 ✖ nx run products:lint 6 > eslint . 7 8 ~/vue-app/modules/products/src/lib/products.vue 9 5:1 error A project tagged with "scope:products" can only depend on libs tagged with "scope:products", "scope:shared" @nx/enforce-module-boundaries 10 111 problem (1 error, 0 warnings) 12 13 ✔ nx run vue-app:lint (892ms) 14 ✔ nx run vue-app:lint (1s) 15 16—————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————— 17 18 NX Ran targets lint for 4 projects (1s) 19 204/5 succeeded [2 read from cache] 21 221/5 targets failed, including the following: 23 24 - nx run products:lint 25

Learn more about how to enforce module boundaries.

Migrating to a Monorepo

When you are ready to add another application to the repo, you'll probably want to move myvueapp to its own folder. To do this, you can run the convert-to-monorepo generator or manually move the configuration files.

Fast CI ⚡

Repository with Nx

Make sure you have completed the previous sections of this tutorial before starting this one. If you want a clean starting point, you can check out the reference code as a starting point.

This tutorial walked you through how Nx can improve the local development experience, but the biggest difference Nx makes is in CI. As repositories get bigger, making sure that the CI is fast, reliable and maintainable can get very challenging. Nx provides a solution.

Connect to Nx Cloud

Nx Cloud is a companion app for your CI system that provides remote caching, task distribution, e2e tests deflaking, better DX and more.

Now that we're working on the CI pipeline, it is important for your changes to be pushed to a GitHub repository.

  1. Commit your existing changes with git add . && git commit -am "updates"
  2. Create a new GitHub repository
  3. Follow GitHub's instructions to push your existing code to the repository

Now connect your repository to Nx Cloud with the following command:

npx nx connect

A browser window will open to register your repository in your Nx Cloud account. The link is also printed to the terminal if the windows does not open, or you closed it before finishing the steps. The app will guide you to create a PR to enable Nx Cloud on your repository.

Once the PR is created, merge it into your main branch.

And make sure you pull the latest changes locally:

git pull

You should now have an nxCloudAccessToken property specified in the nx.json file.

Create a CI Workflow

Use the following command to generate a CI workflow file.

npx nx generate ci-workflow --ci=github

This generator creates a .github/workflows/ci.yml file that contains a CI pipeline that will run the lint, test, build and e2e tasks for projects that are affected by any given PR. Since we are using Nx Cloud, the pipeline will also distribute tasks across multiple machines to ensure fast and reliable CI runs.

The key lines in the CI pipeline are:

.github/workflows/ci.yml
1name: CI 2# ... 3jobs: 4 main: 5 runs-on: ubuntu-latest 6 steps: 7 - uses: actions/checkout@v4 8 with: 9 fetch-depth: 0 10 # This enables task distribution via Nx Cloud 11 # Run this command as early as possible, before dependencies are installed 12 # Learn more at https://nx.dev/ci/reference/nx-cloud-cli#npx-nxcloud-startcirun 13 # Connect your workspace by running "nx connect" and uncomment this 14 - run: npx nx-cloud start-ci-run --distribute-on="3 linux-medium-js" --stop-agents-after="build" 15 - uses: actions/setup-node@v3 16 with: 17 node-version: 20 18 cache: 'npm' 19 - run: npm ci --legacy-peer-deps 20 - uses: nrwl/nx-set-shas@v4 21 # Nx Affected runs only tasks affected by the changes in this PR/commit. Learn more: https://nx.dev/ci/features/affected 22 - run: npx nx affected -t lint test build 23

Open a Pull Request

Commit the changes and open a new PR on GitHub.

git add .

git commit -m 'add CI workflow file'

git push origin add-workflow

When you view the PR on GitHub, you will see a comment from Nx Cloud that reports on the status of the CI run.

Nx Cloud report

The See all runs link goes to a page with the progress and results of tasks that were run in the CI pipeline.

Run details

For more information about how Nx can improve your CI pipeline, check out one of these detailed tutorials:

Next Steps

Connect with the rest of the Nx community with these resources:

Building a Single React App with Nx

In this tutorial you'll learn how to use React with Nx in a "standalone" (non-monorepo) setup.

What will you learn?

  • how to add Nx to a React and Vite project
  • how to run a single task (i.e. serve your app) or run multiple tasks in parallel
  • how to leverage code generators to scaffold components
  • how to modularize your codebase and impose architectural constraints for better maintainability
  • how to speed up CI with Nx Cloud ⚡
Looking for React monorepos?

Note, this tutorial sets up a repo with a single application at the root level that breaks out its code into libraries to add structure. If you are looking for a React monorepo setup then check out our React monorepo tutorial.

We're going to start with a default React application and progressively add the core of Nx, then use the @nx/react plugin. Visit our "Why Nx" page to learn more about plugins and what role they play in the Nx architecture.

Final Code

Here's the source code of the final result for this tutorial.

Creating a new React App

Create a new React application that uses Vite with the following command:

~

npm create vite react-app -- --template=react-ts

1 2Scaffolding project in ~/react-app... 3 4Done. Now run: 5 6 cd react-app 7 npm install 8 npm run dev 9

Once you have run npm install, set up Git with the following commands:

git init

git add .

git commit -m "initial commit"

Your repository should now have the following structure:

1└─ react-app 2 ├─ ... 3 ├─ public 4 │ └─ ... 5 ├─ src 6 │ ├─ assets 7 │ ├─ App.css 8 │ ├─ App.tsx 9 │ ├─ index.css 10 │ └─ main.tsx 11 ├─ .eslintrc.cjs 12 ├─ index.html 13 ├─ package.json 14 ├─ README.md 15 ├─ tsconfig.json 16 ├─ tsconfig.node.json 17 └─ vite.config.ts 18

The setup includes..

  • a new React application at the root of the repository (src)
  • ESLint preconfigured
  • Vite preconfigured

You can build the application with the following command:

1npm run build 2

Add Nx

Nx offers many features, but at its core, it is a task runner. Out of the box, it can:

After the initial set up, you can incrementally add on other features that would be helpful in your organization.

To enable Nx in your repository, run a single command:

npx nx@latest init

This command will download the latest version of Nx and help set up your repository to take advantage of it.

First, the script will propose installing some plugins based on the packages that are being used in your repository.

  • Leave the plugins deselected so that we can explore what Nx provides without any plugins.

Second, the script asks a series of questions to help set up caching for you.

  • Which scripts are cacheable? - Choose build and lint
  • Does the "build" script create any outputs? - Enter dist
  • Does the "lint" script create any outputs? - Enter nothing
  • Would you like remote caching to make your build faster? - Choose Skip for now

We'll enable Nx Cloud and set up remote caching later in the tutorial.

Caching Pre-configured

Nx has been configured to run your npm scripts as Nx tasks. You can run a single task like this:

npx nx build react-app

During the init script, Nx also configured caching for these tasks. You can see in the nx.json file that the build and lint targets have the cache property set to true and the build target specifies that its output goes to the project's dist folder.

nx.json
1{ 2 "$schema": "./node_modules/nx/schemas/nx-schema.json", 3 "targetDefaults": { 4 "build": { 5 "outputs": ["{projectRoot}/dist"], 6 "cache": true 7 }, 8 "lint": { 9 "cache": true 10 } 11 }, 12 "defaultBase": "main" 13} 14

Try running build for the react-app app a second time:

npx nx build react-app

The first time nx build was run, it took about 2 seconds - just like running npm run build. But the second time you run nx build, it completes instantly and displays this message:

1Nx read the output from the cache instead of running the command for 1 out of 1 tasks. 2

You can see the same caching behavior working when you run npx nx lint.

Create a Task Pipeline

If you look at the build script in package.json, you'll notice that it is actually doing two things. First, it runs tsc to type check the application and then it uses Vite to build the application.

package.json
1{ 2 "scripts": { 3 "build": "tsc && vite build" 4 } 5} 6

Let's split this into two separate tasks, so we can run typecheck without running the build task.

package.json
1{ 2 "scripts": { 3 "typecheck": "tsc", 4 "build": "vite build" 5 } 6} 7

But we also want to make sure that typecheck is always run when you run the build task. Nx can take care of this for you with a task pipeline. The dependsOn property in nx.json can be used to ensure that all task dependencies are run first.

nx.json
1{ 2 "targetDefaults": { 3 "build": { 4 "outputs": ["{projectRoot}/dist"], 5 "cache": true, 6 "dependsOn": ["typecheck"] 7 }, 8 "lint": { 9 "cache": true 10 } 11 } 12} 13
Project-Specific Settings

The targetDefaults in the nx.json file will apply to all the projects in your repository. If you want to specify these options for a specific project, you can set them under nx.targets.build in that project's package.json file.

Now if you run nx build, Nx will run typecheck first.

~/react-app

npx nx build

1> nx run react-app:typecheck 2 3 4> react-app@0.0.0 typecheck 5> tsc 6 7 8> nx run react-app:build 9 10 11> react-app@0.0.0 build 12> vite build 13 14vite v5.2.12 building for production... 15✓ 34 modules transformed. 16dist/index.html 0.46 kB │ gzip: 0.30 kB 17dist/assets/react-CHdo91hT.svg 4.13 kB │ gzip: 2.05 kB 18dist/assets/index-DiwrgTda.css 1.39 kB │ gzip: 0.72 kB 19dist/assets/index-DVoHNO1Y.js 143.36 kB │ gzip: 46.09 kB 20✓ built in 347ms 21 22—————————————————————————————————————————————————————— 23 24 NX Successfully ran target build for project react-app and 1 task it depends on (2s) 25

We can also cache the typecheck task by updating the nx.json file.

nx.json
1{ 2 "$schema": "./node_modules/nx/schemas/nx-schema.json", 3 "targetDefaults": { 4 "typecheck": { 5 "cache": true 6 }, 7 "build": { 8 "outputs": ["{projectRoot}/dist"], 9 "cache": true, 10 "dependsOn": ["typecheck"] 11 }, 12 "lint": { 13 "cache": true 14 } 15 }, 16 "defaultBase": "main" 17} 18

Now, running npx nx build twice will once again complete instantly.

Use Nx Plugins to Enhance Vite Tasks with Caching

You may remember that we defined the outputs property in nx.json when we were answering questions in the nx init script. The value is currently hard-coded so that if you change the output path in your vite.config.ts, you have to remember to also change the outputs array in the build task configuration. This is where plugins can help. Plugins enable better integration with specific tools. The @nx/vite plugin can understand the vite.config.ts file and automatically create and configure tasks based on the settings in that file.

Nx plugins can:

  • automatically configure caching for you, including inputs and outputs based on the underlying tooling configuration
  • create tasks for a project using the tooling configuration files
  • provide code generators to help scaffold out projects
  • automatically keep the tooling versions and configuration files up to date

For this tutorial, we'll just focus on the automatic caching configuration.

First, let's delete the outputs array from nx.json so that we don't override the inferred values from the plugin. Your nx.json should look like this:

nx.json
1{ 2 "$schema": "./node_modules/nx/schemas/nx-schema.json", 3 "targetDefaults": { 4 "typecheck": { 5 "cache": true 6 }, 7 "build": { 8 "cache": true, 9 "dependsOn": ["typecheck"] 10 }, 11 "lint": { 12 "cache": true 13 } 14 }, 15 "defaultBase": "main" 16} 17

Now let's add the @nx/vite plugin:

~/react-app

npx nx add @nx/vite

1✔ Installing @nx/vite... 2✔ Initializing @nx/vite... 3 4 NX Package @nx/vite added successfully. 5

The nx add command installs the version of the plugin that matches your repo's Nx version and runs that plugin's initialization script. For @nx/vite, the initialization script registers the plugin in the plugins array of nx.json and updates any package.json scripts that execute Vite related tasks to run those tasks through Nx. Running the tasks through Nx is necessary for caching and task pipelines to work.

Open the project details view for the demo app and look at the build task. You can view the project details using Nx Console or by running the following command in the terminal:

npx nx show project react-app

Loading...

If you hover over the settings for the build task, you can see where those settings come from. The inputs and outputs are defined by the @nx/vite plugin from the vite.config.ts file where as the dependsOn property we set earlier in the tutorial in the targetDefaults in the nx.json file.

Now let's change where the build results are output to in the vite.config.ts file.

vite.config.ts
1import { defineConfig } from 'vite'; 2import react from '@vitejs/plugin-react'; 3 4// https://vitejs.dev/config/ 5export default defineConfig({ 6 plugins: [react()], 7 build: { 8 outDir: 'dist/react-app', 9 }, 10}); 11

Now if you look at project details view again, you'll see that the outputs property for Nx's caching has been updated to stay in sync with the setting in the vite.config.ts file.

Creating New Components

You can just create new React components as you normally would. However, Nx plugins also ship generators. They allow you to easily scaffold code, configuration or entire projects. Let's add the @nx/react plugin to take advantage of the generators it provides.

npx nx add @nx/react

To see what capabilities the @nx/react plugin ships, run the following command and inspect the output:

react-app

npx nx list @nx/react

1 NX Capabilities in @nx/react: 2 3GENERATORS 4 5init : Initialize the `@nx/react` plugin. 6application : Create a React application. 7library : Create a React library. 8component : Create a React component. 9redux : Create a Redux slice for a project. 10storybook-configuration : Set up storybook for a React app or library. 11component-story : Generate storybook story for a React component 12stories : Create stories/specs for all components declared in an app or library. 13component-cypress-spec : Create a Cypress spec for a UI component that has a story. 14hook : Create a hook. 15host : Generate a host react application 16remote : Generate a remote react application 17cypress-component-configuration : Setup Cypress component testing for a React project 18component-test : Generate a Cypress component test for a React component 19setup-tailwind : Set up Tailwind configuration for a project. 20setup-ssr : Set up SSR configuration for a project. 21federate-module : Federate a module. 22 23EXECUTORS/BUILDERS 24 25module-federation-dev-server : Serve a host or remote application. 26module-federation-ssr-dev-server : Serve a host application along with it's known remotes. 27
Integrate with Your Editor

For a more integrated experience, install the "Nx Console" extension for your code editor. It has support for VSCode, IntelliJ and ships a LSP for Vim. Nx Console provides autocompletion support in Nx configuration files and has UIs for browsing and running generators.

More info can be found in the integrate with editors article.

Run the following command to generate a new "hello-world" component. Note how we append --dry-run to first check the output.

react-app

npx nx g @nx/react:component --directory=src/app/hello-world --skipTests=true hello-world --dry-run

1NX Generating @nx/react:component 2 3✔ Which stylesheet format would you like to use? · css 4✔ Should this component be exported in the project? (y/N) · false 5✔ Where should the component be generated? · src/app/hello-world/hello-world.tsx 6CREATE src/app/hello-world/hello-world.module.css 7CREATE src/app/hello-world/hello-world.tsx 8 9NOTE: The "dryRun" flag means no changes were made. 10

As you can see it generates a new component in the src/app/hello-world/ folder. If you want to actually run the generator, remove the --dry-run flag.

The hello-world component will look like this:

src/app/hello-world/hello-world.tsx
1import styles from './hello-world.module.css'; 2 3export function HelloWorld() { 4 return ( 5 <div className={styles['container']}> 6 <h1>Welcome to HelloWorld!</h1> 7 </div> 8 ); 9} 10 11export default HelloWorld; 12

Let's update the App.tsx file to use the new HelloWorld component:

src/App.tsx
1import './App.css'; 2import HelloWorld from './app/hello-world/hello-world'; 3 4function App() { 5 return ( 6 <> 7 <HelloWorld /> 8 </> 9 ); 10} 11 12export default App; 13

You can view your app with the nx serve command:

npx nx serve

You're ready to go!

In the previous sections you learned about the basics of using Nx, running tasks and navigating an Nx workspace. You're ready to ship features now!

But there's more to learn. You have two possibilities here:

Modularize your React App with Local Libraries

When you develop your React application, usually all your logic sits in the src folder. Ideally separated by various folder names which represent your "domains". As your app grows, this becomes more and more monolithic though.

1└─ react-app 2 ├─ ... 3 ├─ src 4 │ ├─ app 5 │ │ ├─ products 6 │ │ ├─ cart 7 │ │ ├─ ui 8 │ │ ├─ ... 9 │ │ └─ app.tsx 10 │ ├─ ... 11 │ └─ main.tsx 12 ├─ ... 13 ├─ package.json 14 ├─ ... 15

Nx allows you to separate this logic into "local libraries". The main benefits include

  • better separation of concerns
  • better reusability
  • more explicit "APIs" between your "domain areas"
  • better scalability in CI by enabling independent test/lint/build commands for each library
  • better scalability in your teams by allowing different teams to work on separate libraries

Create a Local Library

Let's assume our domain areas include products, orders and some more generic design system components, called ui. We can generate a new library for these areas using the React library generator:

1npx nx g @nx/react:library products --unitTestRunner=vitest --bundler=none --directory=modules/products 2

Note how we use the --directory flag to place the library into a subfolder. You can choose whatever folder structure you like to organize your libraries.

Nx sets up your workspace to work with the modular library architecture, but depending on your existing configuration, you may need to tweak some settings. In this repo, you'll need to make a small change in order to prepare for future steps.

Build Settings

To make sure that the build can correctly pull in code from libraries, we'll update vite.config.ts to account for typescript aliases. Run the following generator to automatically update your configuration file.

npx nx g @nx/vite:setup-paths-plugin

This will update the vite.config.ts file to include the nxViteTsPaths plugin in the plugins array.

vite.config.ts
1import { defineConfig } from 'vite'; 2import react from '@vitejs/plugin-react'; 3import { nxViteTsPaths } from '@nx/vite/plugins/nx-tsconfig-paths.plugin'; 4 5// https://vitejs.dev/config/ 6export default defineConfig({ 7 plugins: [react(), nxViteTsPaths()], 8 build: { 9 outDir: 'dist/react-app', 10 }, 11}); 12

Create More Libraries

Now that the build system is set up, let's generate the orders and ui libraries.

1nx g @nx/react:library orders --unitTestRunner=vitest --bundler=none --directory=modules/orders 2nx g @nx/react:library ui --unitTestRunner=vitest --bundler=none --directory=modules/shared/ui 3

Running the above commands should lead to the following directory structure:

1└─ react-app 2 ├─ ... 3 ├─ modules 4 │ ├─ products 5 │ │ ├─ ... 6 │ │ ├─ project.json 7 │ │ ├─ src 8 │ │ │ ├─ index.ts 9 │ │ │ └─ lib 10 │ │ │ ├─ products.spec.ts 11 │ │ │ └─ products.ts 12 │ │ ├─ tsconfig.json 13 │ │ ├─ tsconfig.lib.json 14 │ │ ├─ tsconfig.spec.json 15 │ │ └─ vite.config.ts 16 │ ├─ orders 17 │ │ ├─ ... 18 │ │ ├─ project.json 19 │ │ ├─ src 20 │ │ │ ├─ index.ts 21 │ │ │ └─ ... 22 │ │ └─ ... 23 │ └─ shared 24 │ └─ ui 25 │ ├─ ... 26 │ ├─ project.json 27 │ ├─ src 28 │ │ ├─ index.ts 29 │ │ └─ ... 30 │ └─ ... 31 ├─ src 32 │ ├─ app 33 │ │ ├─ hello-world 34 │ │ │ ├─ hello-world.module.css 35 │ │ │ └─ hello-world.tsx 36 │ │ └─ ... 37 │ ├─ ... 38 │ └─ main.tsx 39 ├─ ... 40

Each of these libraries

  • has a project details view where you can see the available tasks (e.g. running tests for just orders: nx test orders)
  • has its own project.json file where you can customize targets
  • has a dedicated index.ts file which is the "public API" of the library
  • is mapped in the tsconfig.base.json at the root of the workspace

Importing Libraries into the React Application

All libraries that we generate automatically have aliases created in the root-level tsconfig.base.json.

tsconfig.base.json
1{ 2 "compilerOptions": { 3 ... 4 "paths": { 5 "orders": ["modules/orders/src/index.ts"], 6 "products": ["modules/products/src/index.ts"], 7 "ui": ["modules/shared/ui/src/index.ts"] 8 }, 9 ... 10 }, 11} 12

That way we can easily import them into other libraries and our React application. As an example, let's import the Products component from the products project into our main application. First (if you haven't already), let's set up React Router.

npm add react-router-dom

Configure it in the main.tsx.

src/main.tsx
1import { StrictMode } from 'react'; 2import { BrowserRouter } from 'react-router-dom'; 3import ReactDOM from 'react-dom/client'; 4 5import App from './App'; 6 7const root = ReactDOM.createRoot( 8 document.getElementById('root') as HTMLElement 9); 10 11root.render( 12 <StrictMode> 13 <BrowserRouter> 14 <App /> 15 </BrowserRouter> 16 </StrictMode> 17); 18

Then we can import the Products component into our app.tsx and render it via the routing mechanism whenever a user hits the /products route.

src/App.tsx
1import './App.css'; 2import HelloWorld from './app/hello-world/hello-world'; 3import { Route, Routes } from 'react-router-dom'; 4 5// importing the component from the library 6import { Products } from 'products'; 7 8export function App() { 9 return ( 10 <Routes> 11 <Route path="/" element={<HelloWorld />}></Route> 12 <Route path="/products" element={<Products />}></Route> 13 </Routes> 14 ); 15} 16 17export default App; 18

Serving your app (nx serve) and then navigating to /products should give you the following result:

products route

Let's apply the same steps for our orders library. Import the Orders component into the App.tsx file and render it via the routing mechanism whenever a user hits the /orders route

In the end, your App.tsx should look similar to this:

src/App.tsx
1import './App.css'; 2import HelloWorld from './app/hello-world/hello-world'; 3import { Route, Routes } from 'react-router-dom'; 4import { Products } from 'products'; 5import { Orders } from 'orders'; 6 7export function App() { 8 return ( 9 <Routes> 10 <Route path="/" element={<HelloWorld />}></Route> 11 <Route path="/products" element={<Products />}></Route> 12 <Route path="/orders" element={<Orders />}></Route> 13 </Routes> 14 ); 15} 16 17export default App; 18

Visualizing your Project Structure

Nx automatically detects the dependencies between the various parts of your workspace and builds a project graph. This graph is used by Nx to perform various optimizations such as determining the correct order of execution when running tasks like nx build, identifying affected projects and more. Interestingly you can also visualize it.

Just run:

nx graph

You should be able to see something similar to the following in your browser.

Loading...

Notice how ui is not yet connected to anything because we didn't import it in any of our projects.

Exercise for you: change the codebase such that ui is used by orders and products.

Imposing Constraints with Module Boundary Rules

Once you modularize your codebase you want to make sure that the modules are not coupled to each other in an uncontrolled way. Here are some examples of how we might want to guard our small demo workspace:

  • we might want to allow orders to import from ui but not the other way around
  • we might want to allow orders to import from products but not the other way around
  • we might want to allow all libraries to import the ui components, but not the other way around

When building these kinds of constraints you usually have two dimensions:

  • type of project: what is the type of your library. Example: "feature" library, "utility" library, "data-access" library, "ui" library
  • scope (domain) of the project: what domain area is covered by the project. Example: "orders", "products", "shared" ... this really depends on the type of product you're developing

Nx comes with a generic mechanism that allows you to assign "tags" to projects. "tags" are arbitrary strings you can assign to a project that can be used later when defining boundaries between projects. For example, go to the project.json of your orders library and assign the tags type:feature and scope:orders to it.

modules/orders/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:orders"] 4} 5

Then go to the project.json of your products library and assign the tags type:feature and scope:products to it.

modules/products/project.json
1{ 2 ... 3 "tags": ["type:feature", "scope:products"] 4} 5

Finally, go to the project.json of the ui library and assign the tags type:ui and scope:shared to it.

modules/shared/ui/project.json
1{ 2 ... 3 "tags": ["type:ui", "scope:shared"] 4} 5

Notice how we assign scope:shared to our UI library because it is intended to be used throughout the workspace.

Next, let's come up with a set of rules based on these tags:

  • type:feature should be able to import from type:feature and type:ui
  • type:ui should only be able to import from type:ui
  • scope:orders should be able to import from scope:orders, scope:shared and scope:products
  • scope:products should be able to import from scope:products and scope:shared

To enforce the rules, Nx ships with a custom ESLint rule.

Lint Settings

We want the lint task for the root react-app project to only lint the files for that project (in the src folder), so we'll change the lint command in package.json:

package.json
1{ 2 "scripts": { 3 "lint": "eslint src --ext ts,tsx --report-unused-disable-directives --max-warnings 0" 4 } 5} 6

Install the @nx/eslint-plugin package. This is an ESLint plugin that can be used in the plugins property of your ESLint configuration. There is also an Nx plugin named @nx/eslint that was automatically installed with the @nx/react plugin that was added earlier in the tutorial.

1npx nx add @nx/eslint-plugin 2

We need to update the .eslintrc.cjs file to extend the .eslintrc.base.json file and undo the ignorePattern from that config that ignores every file. The .eslintrc.base.json file serves as a common set of lint rules for every project in the repository.

.eslintrc.cjs
1module.exports = { 2 root: true, 3 env: { browser: true, es2020: true }, 4 extends: [ 5 'eslint:recommended', 6 'plugin:@typescript-eslint/recommended', 7 'plugin:react-hooks/recommended', 8 './.eslintrc.base.json', 9 ], 10 ignorePatterns: ['!**/*', 'dist', '.eslintrc.cjs'], 11 parser: '@typescript-eslint/parser', 12 plugins: ['react-refresh'], 13 rules: { 14 'react-refresh/only-export-components': [ 15 'warn', 16 { allowConstantExport: true }, 17 ], 18 }, 19}; 20

Now we need to update the .eslintrc.base.json file and define the depConstraints in the @nx/enforce-module-boundaries rule:

.eslintrc.base.json
1{ 2 "overrides": [ 3 { 4 "files": ["*.ts", "*.tsx", "*.js", "*.jsx"], 5 "rules": { 6 "@nx/enforce-module-boundaries": [ 7 "error", 8 { 9 "enforceBuildableLibDependency": true, 10 "allow": [], 11 "depConstraints": [ 12 { 13 "sourceTag": "*", 14 "onlyDependOnLibsWithTags": ["*"] 15 }, 16 { 17 "sourceTag": "type:feature", 18 "onlyDependOnLibsWithTags": ["type:feature", "type:ui"] 19 }, 20 { 21 "sourceTag": "type:ui", 22 "onlyDependOnLibsWithTags": ["type:ui"] 23 }, 24 { 25 "sourceTag": "scope:orders", 26 "onlyDependOnLibsWithTags": [ 27 "scope:orders", 28 "scope:products", 29 "scope:shared" 30 ] 31 }, 32 { 33 "sourceTag": "scope:products", 34 "onlyDependOnLibsWithTags": ["scope:products", "scope:shared"] 35 }, 36 { 37 "sourceTag": "scope:shared", 38 "onlyDependOnLibsWithTags": ["scope:shared"] 39 } 40 ] 41 } 42 ] 43 } 44 } 45 ... 46 ] 47} 48

When Nx set up the @nx/eslint plugin, it chose a task name that would not conflict with the pre-existing lint script. Let's overwrite that name so that all the linting tasks use the same lint name. Update the setting in the nx.json file:

nx.json
1{ 2 ... 3 "plugins": [ 4 { 5 "plugin": "@nx/eslint/plugin", 6 "options": { 7 "targetName": "lint" 8 } 9 } 10 ] 11} 12

Test Boundary Rules

To test the boundary rules, go to your modules/products/src/lib/products.tsx file and import the Orders from the orders project:

modules/products/src/lib/products.tsx
1import styles from './products.module.css'; 2 3// This import is not allowed 👇 4import { Orders } from 'orders'; 5 6/* eslint-disable-next-line */ 7export interface ProductsProps {} 8 9export function Products() { 10 return ( 11 <div className={styles['container']}> 12 <h1>Welcome to Products!</h1> 13 </div> 14 ); 15} 16 17export default Products; 18

If you lint your workspace you'll get an error now:

nx run-many -t lint

1✔ nx run orders:lint [existing outputs match the cache, left as is] 2✔ nx run ui:lint (1s) 3 4✖ nx run products:lint 5 Linting "products"... 6 7 /Users/.../react-app/modules/products/src/lib/products.tsx 8 3:1 error A project tagged with "scope:products" can only depend on libs tagged with "scope:products", "scope:shared" @nx/enforce-module-boundaries 9 101 problem (1 error, 0 warnings) 11 12 Lint errors found in the listed files. 13 14✔ nx run react-app:lint (1s) 15 16———————————————————————————————————————————————————————————————————————————————————————————————————————————————————————————— 17 18NX Ran target lint for 4 projects (1s) 19 203/4 succeeded [1 read from cache] 21 221/4 targets failed, including the following: 23 - nx run products:lint 24

If you have the ESLint plugin installed in your IDE you should also immediately see an error.

Learn more about how to enforce module boundaries.

Migrating to a Monorepo

When you are ready to add another application to the repo, you'll probably want to move react-app to its own folder. To do this, you can run the convert-to-monorepo generator or manually move the configuration files.

You can also go through the full React monorepo tutorial

Fast CI ⚡

Repository with Nx

Make sure you have completed the previous sections of this tutorial before starting this one. If you want a clean starting point, you can check out the reference code as a starting point.

This tutorial walked you through how Nx can improve the local development experience, but the biggest difference Nx makes is in CI. As repositories get bigger, making sure that the CI is fast, reliable and maintainable can get very challenging. Nx provides a solution.

Connect to Nx Cloud

Nx Cloud is a companion app for your CI system that provides remote caching, task distribution, e2e tests deflaking, better DX and more.

Now that we're working on the CI pipeline, it is important for your changes to be pushed to a GitHub repository.

  1. Commit your existing changes with git add . && git commit -am "updates"
  2. Create a new GitHub repository
  3. Follow GitHub's instructions to push your existing code to the repository

Now connect your repository to Nx Cloud with the following command:

npx nx connect

A browser window will open to register your repository in your Nx Cloud account. The link is also printed to the terminal if the windows does not open, or you closed it before finishing the steps. The app will guide you to create a PR to enable Nx Cloud on your repository.

Once the PR is created, merge it into your main branch.

And make sure you pull the latest changes locally:

git pull

You should now have an nxCloudAccessToken property specified in the nx.json file.

Create a CI Workflow

Use the following command to generate a CI workflow file.

npx nx generate ci-workflow --ci=github

This generator creates a .github/workflows/ci.yml file that contains a CI pipeline that will run the lint, test, build and e2e tasks for projects that are affected by any given PR. Since we are using Nx Cloud, the pipeline will also distribute tasks across multiple machines to ensure fast and reliable CI runs.

The key lines in the CI pipeline are:

.github/workflows/ci.yml
1name: CI 2# ... 3jobs: 4 main: 5 runs-on: ubuntu-latest 6 steps: 7 - uses: actions/checkout@v4 8 with: 9 fetch-depth: 0 10 # This enables task distribution via Nx Cloud 11 # Run this command as early as possible, before dependencies are installed 12 # Learn more at https://nx.dev/ci/reference/nx-cloud-cli#npx-nxcloud-startcirun 13 # Connect your workspace by running "nx connect" and uncomment this 14 - run: npx nx-cloud start-ci-run --distribute-on="3 linux-medium-js" --stop-agents-after="build" 15 - uses: actions/setup-node@v3 16 with: 17 node-version: 20 18 cache: 'npm' 19 - run: npm ci --legacy-peer-deps 20 - uses: nrwl/nx-set-shas@v4 21 # Nx Affected runs only tasks affected by the changes in this PR/commit. Learn more: https://nx.dev/ci/features/affected 22 - run: npx nx affected -t lint test build 23

Open a Pull Request

Commit the changes and open a new PR on GitHub.

git add .

git commit -m 'add CI workflow file'

git push origin add-workflow

When you view the PR on GitHub, you will see a comment from Nx Cloud that reports on the status of the CI run.

Nx Cloud report

The See all runs link goes to a page with the progress and results of tasks that were run in the CI pipeline.

Run details

For more information about how Nx can improve your CI pipeline, check out one of these detailed tutorials:

Next Steps

Here's some things you can dive into next:

Also, make sure you